#include <bits/stdc++.h>

using namespace std;

int d[9][2] = {
	{ 1, 1 },
	{ 0, 0 },
	{ 0, 2 },
	{ 2, 0 },
	{ 2, 2 },
	{ 1, 0 },
	{ 0, 1 },
	{ 2, 1 },
	{ 1, 2 }
};

int a[3][3];

void del() {
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			a[i][j] = 0;
		}
	}
}

void go( int x, int y ) {
	a[x][y] = 1;
	cout << x + 1 << " " << y + 1 << endl;
	cout.flush();
}

bool checkWin( int x ) {
	for( int i = 0; i < 3; i ++ ) {
		int cnt = 0;
		for( int j = 0; j < 3; j ++ ) {
			cnt += ( a[i][j] == x );
		}
		if( cnt == 3 )
			return true;
	}
	for( int i = 0; i < 3; i ++ ) {
		int cnt = 0;
		for( int j = 0; j < 3; j ++ ) {
			cnt += ( a[j][i] == x );
		}
		if( cnt == 3 )
			return true;
	}
	if( a[0][0] == x && a[1][1] == x && a[2][2] == x )
		return true;
	if( a[2][0] == x && a[1][1] == x && a[0][2] == x )
		return true;
	return false;
}

bool checkWin() {
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			if( a[i][j] )
				continue;
			a[i][j] = 1;
			if( checkWin( 1 ) ) {
				go( i, j );
				return true;
			}
			a[i][j] = 0;
		}
	}
	return false;
}

bool checkBlock() {
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			if( a[i][j] )
				continue;
			a[i][j] = 2;
			if( checkWin( 2 ) ) {
				go( i, j );
				return true;
			}
			a[i][j] = 0;
		}
	}
	return false;
}

void go() {
	if( checkWin() )
		return;
	for( int idx = 0; idx < 9; idx ++ ) {
		int x = d[idx][0];
		int y = d[idx][1];
		if( a[x][y] )
			continue;
		go( x, y );
		break;
	}
}

void game() {
	del();
	while( true ) {
		go();
		string s;
		cin >> s;
		if( s == "lose" )
			exit( 0 );
		if( s == "win" )
			return;
		if( s == "draw" )
			return;
		int x, y;
		cin >> x >> y;
		x --, y --;
		a[x][y] = 2;
	}
}

int main() {
	int n;
	cin >> n;
	for( int i = 0; i < n; i ++ ) {
		game();
	}
	return 0;
}
